/* Replace "dll.h" with the name of your header */
#include "dll.h"



                    //Anzahl der Eingaenge  
const unsigned char inputs = 5;  //5-Ingangen
//Anzahl der Ausgaenge
const unsigned char outputs = 8; //8-Uitgangen

//
//Aufruf von PROFILAB, liest Anzahl der Eingnge 
DLLEXPORT unsigned char _stdcall NumInputs()
{
      return inputs;
}
  
//Aufruf von PROFILAB, liest Anzahl der Ausgaenge 
DLLEXPORT unsigned char _stdcall NumOutputs()
{
      return outputs;
}
  
//Aufruf von PROFILAB, liest die Namen der Eingnge 
DLLEXPORT void _stdcall GetInputName(unsigned char Channel,unsigned char *Name)
{
      //sprintf(Name, "Q%i", Channel); // Name der Ausgaenge hier Q0..Q7
	//sprintf ersetzt durch folgende Methode, ist sicherer
	switch(Channel)
	{
	case 0://Bezeichnung Ausgang-0
			{
			Name[0]= 'I';
			Name[1]= '4';
			Name[2]= 0;
			break;
			}
	case 1://Bezeichnung Ingang-1
			{
			Name[0]= 'I';
			Name[1]= '3';
			Name[2]= 0;
			break;
			}
	case 2://Bezeichnung Ausgang-2
			{
			Name[0]= 'I';
			Name[1]= '2';
			Name[2]= 0;
			break;
			}
	case 3://Bezeichnung Ausgang-3
			{
			Name[0]= 'I';
			Name[1]= '1';
			Name[2]= 0;
			break;
			}
	case 4://Bezeichnung Ausgang-4
			{
			Name[0]= 'S';
			Name[1]= 'E';
			Name[2]= 'T';
			Name[3]= 0;
			break;
			}
	default:;
			}

}
  
//Aufruf von PROFILAB, liest die Namen der Eingnge 
DLLEXPORT void _stdcall GetOutputName(unsigned char Channel,unsigned char *Name)
{
      //sprintf(Name, "Q%i", Channel); // Name der Ausgaenge hier Q0..Q7
	//sprintf ersetzt durch folgende Methode, ist sicherer
	switch(Channel)
	{
	case 0://Bezeichnung Ausgang-0
			{
			Name[0]= '4';
			Name[1]= 'A';
			Name[2]= 0;
			break;
			}
	case 1://Bezeichnung Ausgang-1
			{
			Name[0]= '4';
			Name[1]= 'B';
			Name[2]= 0;
			break;
			}
	case 2://Bezeichnung Ausgang-2
			{
			Name[0]= '3';
			Name[1]= 'A';
			Name[2]= 0;
			break;
			}
	case 3://Bezeichnung Ausgang-3
			{
			Name[0]= '3';
			Name[1]= 'B';
			Name[2]= 0;
			break;
			}
	case 4://Bezeichnung Ausgang-4
			{
			Name[0]= '2';
			Name[1]= 'A';
			Name[2]= 0;
			break;
			}
	case 5://Bezeichnung Ausgang-5
			{
			Name[0]= '2';
			Name[1]= 'B';
			Name[2]= 0;
			break;
			}
	case 6://Bezeichnung Ausgang-6
			{
			Name[0]= '1';
			Name[1]= 'A';
			Name[2]= 0;
			break;
			}
	case 7://Bezeichnung Ausgang-7
			{
			Name[0]= '1';
			Name[1]= 'B';
			Name[2]= 0;
			break;
			}
	default:;
			}

}
  

DLLEXPORT void _stdcall CSimStart(double *PInput, double *POutput, double *PUser)
{
      
}
  
//Aufruf von PROFILAB,hier steht die eigentliche Funktion der DLL
//
DLLEXPORT void _stdcall CCalculate(double *PInput, double *POutput, double *PUser)
{
int i;
if (PInput[0] > 2.5) //Rela is activated
{ 
  POutput[0]=PInput[0];
  POutput[2]=PInput[1];
  POutput[4]=PInput[2];
  POutput[6]=PInput[3];
  POutput[1]=0;
  POutput[3]=0;
  POutput[5]=0;
  POutput[7]=0;
}
else  // Relay is deactivated
{
  POutput[1]=PInput[0];
  POutput[3]=PInput[1];
  POutput[5]=PInput[2];
  POutput[7]=PInput[3]; 
  POutput[0]=0;
  POutput[2]=0;
  POutput[4]=0;
  POutput[6]=0;
}          
 

      
}
  
// Aufruf von PROFILAB, wird beim Simulations-Stop aufgerufen
DLLEXPORT void _stdcall CSimStop(double *PInput, double *POutput, double *PUser)
{
//nichts zu tun
}
// erforderlich fr MessageBox
int WINAPI WinMain ( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR szComdLine, int iCmdShow);  
//Aufruf von PROFILAB, wird im Configurations-Men aufgerufen

DLLEXPORT void _stdcall CConfigure(double *PUser)
{
MessageBox(NULL,TEXT("no config"),TEXT("Config"), MB_OK);
}





BOOL APIENTRY DllMain (HINSTANCE hInst     /* Library instance handle. */ ,
                       DWORD reason        /* Reason this function is being called. */ ,
                       LPVOID reserved     /* Not used. */ )
{
    switch (reason)
    {
      case DLL_PROCESS_ATTACH:
        break;

      case DLL_PROCESS_DETACH:
        break;

      case DLL_THREAD_ATTACH:
        break;

      case DLL_THREAD_DETACH:
        break;
    }

    /* Returns TRUE on success, FALSE on failure */
    return TRUE;
}
